# Tom Wexler
# 11/11/13
# Algorithms for search

import time

# Assuming A is sorted in non-decreasing order,
# determine whether x appears in A.
# If so, return the index of x, otherwise, return -1.
def find(A, x) :
    return fin(A, x, 0, len(A))

# Assuming A is sorted in non-decreasing order,
# determine whether x appears in A between indices s and t.
# If so, return the index of x, otherwise, return -1.
def fin(A, x, s, t) :
    #print("Searching through",t-s,"elements.")
    if (s >= t) :
        return -1
    m = (s+t)//2
    if A[m] == x :
        return m
    elif A[m] > x :
        return fin(A, x, s, m)
    else :
        return fin(A, x, m+1, t)

def simpleFind(A,x) :
    for i in range(len(A)) :
        #print("Searching through",len(A)-i,"elements.")
        if A[i] == x :
            return i
    return -1

def main() :
    
    A = []
    for i in range(10000) :
        A.append(i*i)
    print("List created")
    
    input("Press enter for binary search")

    start = time.clock()
    print(find(A,62))
    end = time.clock()
    print("Binary search done in",end-start,"seconds.")
    
    input("Press enter for simple search")
    
    start = time.clock()
    print(simpleFind(A,62))
    end = time.clock()
    print("Simple search done in",end-start,"seconds.")
    
main()